Index: components/hst/src/main/java/org/onehippo/cms7/essentials/components/CommonComponent.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- components/hst/src/main/java/org/onehippo/cms7/essentials/components/CommonComponent.java	(revision e238c5041af5874be390d278728a6aa6e938a880)
+++ components/hst/src/main/java/org/onehippo/cms7/essentials/components/CommonComponent.java	(revision 9f58b186f7f34b8e33e336bba2fbc3b067b3a2f3)
@@ -1,5 +1,5 @@
 /*
- * Copyright 2014-2015 Hippo B.V. (http://www.onehippo.com)
+ * Copyright 2014-2017 Hippo B.V. (http://www.onehippo.com)
  *
  * Licensed under the Apache License, Version 2.0 (the "License");
  * you may not use this file except in compliance with the License.
@@ -224,10 +224,33 @@
      *
      * @param path document (or folder) path relative to site-root
      * @return bean identified by path. Site root bean if path empty or no corresponding bean.
+     * @deprecated use the non-static {@code doGetScopeBean()} instead.
      */
     public static HippoBean getScopeBean(final String path) {
         final HstRequestContext context = RequestContextProvider.get();
         final HippoBean siteBean = context.getSiteContentBaseBean();
+
+        if (!Strings.isNullOrEmpty(path)) {
+            final String myPath = PathUtils.normalizePath(path);
+            log.debug("Looking for bean {}", myPath);
+            HippoBean scope = siteBean.getBean(myPath);
+            if (scope != null) {
+                return scope;
+            }
+            log.warn("Bean was null for selected path:  {}", myPath);
+        }
+        return siteBean;
+    }
+
+    /**
+     * Find HippoBean for given path. If path is null or empty, site root bean will be returned.
+     *
+     * @param path document (or folder) path relative to site-root.
+     * @return bean identified by path. Site root bean if path empty or no corresponding bean.
+     */
+    public HippoBean doGetScopeBean(final String path) {
+        final HstRequestContext context = RequestContextProvider.get();
+        final HippoBean siteBean = context.getSiteContentBaseBean();
 
         if (!Strings.isNullOrEmpty(path)) {
             final String myPath = PathUtils.normalizePath(path);
Index: components/hst/src/main/java/org/onehippo/cms7/essentials/components/EssentialsListComponent.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- components/hst/src/main/java/org/onehippo/cms7/essentials/components/EssentialsListComponent.java	(revision e238c5041af5874be390d278728a6aa6e938a880)
+++ components/hst/src/main/java/org/onehippo/cms7/essentials/components/EssentialsListComponent.java	(revision e55c2c5770786d27de977febf56101c8ac70fa0b)
@@ -1,5 +1,5 @@
 /*
- * Copyright 2014-2015 Hippo B.V. (http://www.onehippo.com)
+ * Copyright 2014-2017 Hippo B.V. (http://www.onehippo.com)
  *
  * Licensed under the Apache License, Version 2.0 (the "License");
  * you may not use this file except in compliance with the License.
@@ -123,7 +123,7 @@
         }
 
         if (scope == null) {
-            scope = getScopeBean(path);
+            scope = doGetScopeBean(path);
         }
         return scope;
     }
Index: components/hst/src/main/java/org/onehippo/cms7/essentials/components/EssentialsBlogAuthorPostsComponent.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- components/hst/src/main/java/org/onehippo/cms7/essentials/components/EssentialsBlogAuthorPostsComponent.java	(revision e238c5041af5874be390d278728a6aa6e938a880)
+++ components/hst/src/main/java/org/onehippo/cms7/essentials/components/EssentialsBlogAuthorPostsComponent.java	(revision e55c2c5770786d27de977febf56101c8ac70fa0b)
@@ -1,5 +1,5 @@
 /*
- * Copyright 2014-2015 Hippo B.V. (http://www.onehippo.com)
+ * Copyright 2014-2017 Hippo B.V. (http://www.onehippo.com)
  *
  * Licensed under the Apache License, Version 2.0 (the "License");
  * you may not use this file except in compliance with the License.
@@ -69,7 +69,7 @@
                 if (scopePath != null && scopePath.startsWith("/")) {
                     scopePath = SiteUtils.relativePathFrom(scopePath, context);
                 }
-                final HippoBean scopeBean = getScopeBean(scopePath);
+                final HippoBean scopeBean = doGetScopeBean(scopePath);
                 try {
                     for (AuthorEntry author : authors) {
                         final HstQuery hstQuery = ContentBeanUtils.createIncomingBeansQuery(author, scopeBean, getSearchDepth(), clazz, true);