Index: frontend-ng/src/styles/_tree.scss
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- frontend-ng/src/styles/_tree.scss	(date 1557493566000)
+++ frontend-ng/src/styles/_tree.scss	(date 1557499066000)
@@ -125,9 +125,18 @@
     padding: 0;
   }
 
-  .angular-ui-tree-title-wrapper md-icon {
-    font-size: 20px;
-    line-height: 24px;
+  .hippo-tree-item-label {
+    display: inline-block;
+    white-space: nowrap;
+  }
+
+  .angular-ui-tree-title-wrapper {
+    white-space: nowrap;
+
+    md-icon {
+      font-size: 20px;
+      line-height: 24px;
+    }
   }
 }
 
Index: frontend-ng/src/app/channel/siteMenuEditor/internalLinkPicker/itemListing.component.js
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- frontend-ng/src/app/channel/siteMenuEditor/internalLinkPicker/itemListing.component.js	(date 1557493566000)
+++ frontend-ng/src/app/channel/siteMenuEditor/internalLinkPicker/itemListing.component.js	(date 1557497312000)
@@ -16,6 +16,7 @@
 
 import controller from './itemListing.controller';
 import template from './itemListing.html';
+import './itemListingComponent.scss';
 
 const itemListingComponent = {
   bindings: {
Index: frontend-ng/src/app/channel/siteMenuEditor/internalLinkPicker/itemListingComponent.scss
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- frontend-ng/src/app/channel/siteMenuEditor/internalLinkPicker/itemListingComponent.scss	(date 1557497416000)
+++ frontend-ng/src/app/channel/siteMenuEditor/internalLinkPicker/itemListingComponent.scss	(date 1557497416000)
@@ -0,0 +1,23 @@
+/*!
+ * Copyright 2019 Hippo B.V. (http://www.onehippo.com)
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *   http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+item-listing {
+  .single-line {
+    text-overflow: ellipsis;
+    overflow: hidden;
+    white-space: nowrap;
+  }
+}
\ No newline at end of file
Index: frontend-ng/src/app/channel/siteMenuEditor/internalLinkPicker/itemListing.html
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- frontend-ng/src/app/channel/siteMenuEditor/internalLinkPicker/itemListing.html	(date 1557493566000)
+++ frontend-ng/src/app/channel/siteMenuEditor/internalLinkPicker/itemListing.html	(date 1557497903000)
@@ -1,5 +1,5 @@
 <!--
-  Copyright 2016-2018 Hippo B.V. (http://www.onehippo.com)
+  Copyright 2016-2019 Hippo B.V. (http://www.onehippo.com)
 
   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
@@ -15,15 +15,16 @@
   -->
 
 <section>
-  <md-subheader>{{ 'PICKER_LISTING_NAME' | translate }}</md-subheader>
+  <md-subheader>{{ ::'PICKER_LISTING_NAME' | translate }}</md-subheader>
   <md-list>
     <md-list-item ng-repeat="item in $ctrl.items"
-                  ng-if="item.selectable"
+                  ng-if="::item.selectable"
                   ng-class="{ active: $ctrl.selectedItem === item }"
                   scroll-to-if="$ctrl.selectedItem === item"
+                  title="{{::item.displayName}}"
                   ng-click="$ctrl.selectItem(item)">
       <md-icon md-svg-icon="{{ $ctrl.getItemIcon(item) }}"></md-icon>
-      <p>{{item.displayName}}</p>
+      <p class="single-line">{{::item.displayName}}</p>
     </md-list-item>
   </md-list>
 </section>
Index: frontend-ng/src/app/channel/siteMenuEditor/tree/nodes.template.html
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- frontend-ng/src/app/channel/siteMenuEditor/tree/nodes.template.html	(date 1557493566000)
+++ frontend-ng/src/app/channel/siteMenuEditor/tree/nodes.template.html	(date 1557499001000)
@@ -13,18 +13,18 @@
 - See the License for the specific language governing permissions and
 - limitations under the License.
 -->
-<ol
+<div
   ui-tree-nodes
   ng-model="$ctrl.items"
   ng-if="$ctrl.items">
-    <li
+    <div
       ng-repeat="item in $ctrl.items"
       ui-tree-node
       ng-if="$ctrl.hippoTree.displayItem(item)"
       ng-class="{active: $ctrl.hippoTree.selectedItem.id === item.id}">
-        <div ng-click="$ctrl.hippoTree.selectItem(item)">
+        <div class="hippo-tree-item-label" ng-click="$ctrl.hippoTree.selectItem(item)">
           <hippo-tree-node data-item="item"></hippo-tree-node>
         </div>
         <hippo-tree-nodes ng-if="!item.collapsed" data-items="item.items"></hippo-tree-nodes>
-    </li>
-</ol>
+    </div>
+</div>